-- updates for 6.0

ALTER TABLE MA_USER ADD ( SALT VARCHAR2(250) NULL, ALGORITHM VARCHAR2(50) NULL )
;

UPDATE MA_USER SET ALGORITHM = 'MD5' WHERE SALT is null
;
CREATE OR REPLACE PROCEDURE INSERT_MA_USER(
  p_username IN varchar2,
  p_password IN varchar2,
  p_user_type IN number,
  p_salt IN varchar2,
  p_algorithm IN varchar2,
  p_pk OUT number)
AS
BEGIN
   INSERT INTO MA_USER (USERNAME,PASSWORD,USER_TYPE,SALT,ALGORITHM) VALUES (p_username, p_password, p_user_type, p_salt, p_algorithm) RETURNING USER_ID INTO p_pk;
END;
/
;

UPDATE MA_USER SET USER_TYPE = 127 WHERE USER_TYPE = 1
;
UPDATE MA_USER SET USER_TYPE = 15 WHERE USER_TYPE = 2
;

CREATE TABLE REGISTRY ( 
	ID NUMBER(18) NOT NULL,
	URL VARCHAR2(255),
	USERNAME VARCHAR2(255),
	PASSWORD VARCHAR2(255),
	DESCRIPTION VARCHAR2(255),
	TECHNOLOGY VARCHAR2(255),
	PRIMARY KEY (ID) 
)
;

CREATE SEQUENCE REGISTRY_ID_SEQ
INCREMENT BY 1
START WITH 1
NOMAXVALUE
MINVALUE 1
NOCYCLE
NOCACHE
NOORDER
;

CREATE OR REPLACE TRIGGER SET_REGISTRY_ID
BEFORE INSERT
ON REGISTRY
FOR EACH ROW
BEGIN
  SELECT REGISTRY_ID_SEQ.NEXTVAL
  INTO :NEW.ID
  FROM DUAL;
END;
/
;

CREATE OR REPLACE PROCEDURE INSERT_REGISTRY(
  p_url IN varchar2,
  p_username IN varchar2,
  p_password IN varchar2,
  p_description IN varchar2,
  p_technology IN varchar2,
  p_pk OUT number)
AS
BEGIN
   INSERT INTO REGISTRY (URL,USERNAME,PASSWORD,DESCRIPTION,TECHNOLOGY) VALUES (p_url,p_username, p_password,p_description,p_technology) RETURNING ID INTO p_pk;
END;
/
;

    
-- always last
update DB_VERSION SET VERSION = '6.0'
;

